## org.hibernate.persister.entity
Class DiscriminatorType

    java.lang.Object
      org.hibernate.type.AbstractType
          org.hibernate.persister.entity.DiscriminatorType

All Implemented Interfaces:
  Serializable, Type

    public class DiscriminatorType

extends AbstractType

TODO : javadoc

See Also:
  Serialized Form

Field Summary

Fields inherited from class org.hibernate.type.AbstractType
`LEGACY_DEFAULT_SIZE, LEGACY_DICTATED_SIZE`

Constructor Summary
`DiscriminatorType(Type underlyingType, Loadable persister)`

Method Summary
`Object` `deepCopy(Object value, SessionFactoryImplementor factory)` Return a deep copy of the persistent state, stopping at entities and at collections.
`Size[]` `defaultSizes(Mapping mapping)` Defines the column sizes to use according to this type if the user did not explicitly say (and if no `Type.dictatedSizes(org.hibernate.engine.spi.Mapping)` were given).
`Size[]` `dictatedSizes(Mapping mapping)` Return the column sizes dictated by this type.
`Object` `fromXMLNode(org.dom4j.Node xml, Mapping factory)` Parse the XML representation of an instance.
`int` `getColumnSpan(Mapping mapping)` How many columns are used to persist this type.
`String` `getName()` Returns the abbreviated name of the type.
`Class` `getReturnedClass()` The class returned by `Type.nullSafeGet(java.sql.ResultSet, java.lang.String[], org.hibernate.engine.spi.SessionImplementor, java.lang.Object)` methods.
`boolean` `isDirty(Object old, Object current, boolean[] checkable, SessionImplementor session)` Should the parent be considered dirty, given both the old and current value?
`boolean` `isMutable()` Are objects of this type mutable.
`Object` `nullSafeGet(ResultSet rs, String[] names, SessionImplementor session, Object owner)` Extract a value of the `mapped class` from the JDBC result set.
`Object` `nullSafeGet(ResultSet rs, String name, SessionImplementor session, Object owner)` Extract a value of the `mapped class` from the JDBC result set.
`void` `nullSafeSet(PreparedStatement st, Object value, int index, boolean[] settable, SessionImplementor session)` Bind a value represented by an instance of the `mapped class` to the JDBC prepared statement, ignoring some columns as dictated by the 'settable' parameter.
`void` `nullSafeSet(PreparedStatement st, Object value, int index, SessionImplementor session)` Bind a value represented by an instance of the `mapped class` to the JDBC prepared statement.
`Object` `replace(Object original, Object target, SessionImplementor session, Object owner, Map copyCache)` During merge, replace the existing (target) value in the entity we are merging to with a new (original) value from the detached entity we are merging.
`void` `setToXMLNode(org.dom4j.Node node, Object value, SessionFactoryImplementor factory)` A representation of the value to be embedded in an XML element.
`int[]` `sqlTypes(Mapping mapping)` Return the JDBC types codes (per `Types`) for the columns mapped by this type.
`boolean[]` `toColumnNullness(Object value, Mapping mapping)` Given an instance of the type, return an array of boolean, indicating which mapped columns would be null.
`String` `toLoggableString(Object value, SessionFactoryImplementor factory)` Generate a representation of the value for logging purposes.

Methods inherited from class org.hibernate.type.AbstractType
`assemble, beforeAssemble, compare, disassemble, getHashCode, getHashCode, getSemiResolvedType, hydrate, isAnyType, isAssociationType, isCollectionType, isComponentType, isDirty, isEntityType, isEqual, isEqual, isModified, isSame, isXMLElement, replace, replaceNode, resolve, semiResolve`

Methods inherited from class java.lang.Object
`clone, equals, finalize, getClass, hashCode, notify, notifyAll, toString, wait, wait, wait`

Constructor Detail

### DiscriminatorType

    public DiscriminatorType(Type underlyingType,
                             Loadable persister)

Method Detail

### getReturnedClass

    public Class getReturnedClass()

  Description copied from interface: `Type`
  The class returned by `Type.nullSafeGet(java.sql.ResultSet, java.lang.String[], org.hibernate.engine.spi.SessionImplementor, java.lang.Object)` methods. This is used to establish the class of an array of this type.

  Returns:
    The java type class handled by this type.

### getName

    public String getName()

  Description copied from interface: `Type`
  Returns the abbreviated name of the type.

  Returns:
    String the Hibernate type name

### isMutable

    public boolean isMutable()

  Description copied from interface: `Type`
  Are objects of this type mutable. (With respect to the referencing object ... entities and collections are considered immutable because they manage their own internal state.)

  Returns:
    boolean

### nullSafeGet

    public Object nullSafeGet(ResultSet rs,
                              String[] names,
                              SessionImplementor session,
                              Object owner)
                       throws HibernateException,
                              SQLException

  Description copied from interface: `Type`
  Extract a value of the `mapped class` from the JDBC result set. Implementors should handle possibility of null values.

  Parameters:
    `rs` - The result set from which to extract value.
    `names` - the column names making up this type value (use to read from result set)
    `session` - The originating session
    `owner` - the parent entity
  Returns:
    The extracted value
  Throws:
    `HibernateException` - An error from Hibernate
    `SQLException` - An error from the JDBC driver
  See Also:
    `alternative, 2-phase property initialization`

### nullSafeGet

    public Object nullSafeGet(ResultSet rs,
                              String name,
                              SessionImplementor session,
                              Object owner)
                       throws HibernateException,
                              SQLException

  Description copied from interface: `Type`
  Extract a value of the `mapped class` from the JDBC result set. Implementors should handle possibility of null values. This form might be called if the type is known to be a single-column type.

  Parameters:
    `rs` - The result set from which to extract value.
    `name` - the column name making up this type value (use to read from result set)
    `session` - The originating session
    `owner` - the parent entity
  Returns:
    The extracted value
  Throws:
    `HibernateException` - An error from Hibernate
    `SQLException` - An error from the JDBC driver

### nullSafeSet

    public void nullSafeSet(PreparedStatement st,
                            Object value,
                            int index,
                            boolean[] settable,
                            SessionImplementor session)
                     throws HibernateException,
                            SQLException

  Description copied from interface: `Type`
  Bind a value represented by an instance of the `mapped class` to the JDBC prepared statement, ignoring some columns as dictated by the 'settable' parameter. Implementors should handle the possibility of null values. A multi-column type should bind parameters starting from `index`.

  Parameters:
    `st` - The JDBC prepared statement to which to bind
    `value` - the object to write
    `index` - starting parameter bind index
    `settable` - an array indicating which columns to bind/ignore
    `session` - The originating session
  Throws:
    `HibernateException` - An error from Hibernate
    `SQLException` - An error from the JDBC driver

### nullSafeSet

    public void nullSafeSet(PreparedStatement st,
                            Object value,
                            int index,
                            SessionImplementor session)
                     throws HibernateException,
                            SQLException

  Description copied from interface: `Type`
  Bind a value represented by an instance of the `mapped class` to the JDBC prepared statement. Implementors should handle possibility of null values. A multi-column type should bind parameters starting from `index`.

  Parameters:
    `st` - The JDBC prepared statement to which to bind
    `value` - the object to write
    `index` - starting parameter bind index
    `session` - The originating session
  Throws:
    `HibernateException` - An error from Hibernate
    `SQLException` - An error from the JDBC driver

### toLoggableString

    public String toLoggableString(Object value,
                                   SessionFactoryImplementor factory)
                            throws HibernateException

  Description copied from interface: `Type`
  Generate a representation of the value for logging purposes.

  Parameters:
    `value` - The value to be logged
    `factory` - The session factory
  Returns:
    The loggable representation
  Throws:
    `HibernateException` - An error from Hibernate

### deepCopy

    public Object deepCopy(Object value,
                           SessionFactoryImplementor factory)
                    throws HibernateException

  Description copied from interface: `Type`
  Return a deep copy of the persistent state, stopping at entities and at collections.

  Parameters:
    `value` - The value to be copied
    `factory` - The session factory
  Returns:
    The deep copy
  Throws:
    `HibernateException` - An error from Hibernate

### replace

    public Object replace(Object original,
                          Object target,
                          SessionImplementor session,
                          Object owner,
                          Map copyCache)
                   throws HibernateException

  Description copied from interface: `Type`
  During merge, replace the existing (target) value in the entity we are merging to with a new (original) value from the detached entity we are merging. For immutable objects, or null values, it is safe to simply return the first parameter. For mutable objects, it is safe to return a copy of the first parameter. For objects with component values, it might make sense to recursively replace component values.

  Parameters:
    `original` - the value from the detached entity being merged
    `target` - the value in the managed entity
    `session` - The originating session
    `owner` - The owner of the value
    `copyCache` - The cache of already copied/replaced values
  Returns:
    the value to be merged
  Throws:
    `HibernateException` - An error from Hibernate

### toColumnNullness

    public boolean[] toColumnNullness(Object value,
                                      Mapping mapping)

  Description copied from interface: `Type`
  Given an instance of the type, return an array of boolean, indicating which mapped columns would be null.

  Parameters:
    `value` - an instance of the type
    `mapping` - The mapping abstraction
  Returns:
    array indicating column nullness for a value instance

### isDirty

    public boolean isDirty(Object old,
                           Object current,
                           boolean[] checkable,
                           SessionImplementor session)
                    throws HibernateException

  Description copied from interface: `Type`
  Should the parent be considered dirty, given both the old and current value?

  Parameters:
    `old` - the old value
    `current` - the current value
    `checkable` - An array of booleans indicating which columns making up the value are actually checkable
    `session` - The session from which the request originated.
  Returns:
    true if the field is dirty
  Throws:
    `HibernateException` - A problem occurred performing the checking

### sqlTypes

    public int[] sqlTypes(Mapping mapping)
                   throws MappingException

  Description copied from interface: `Type`
  Return the JDBC types codes (per `Types`) for the columns mapped by this type.

  NOTE: The number of elements in this array matches the return from `Type.getColumnSpan(org.hibernate.engine.spi.Mapping)`.

  Parameters:
    `mapping` - The mapping object :/
  Returns:
    The JDBC type codes.
  Throws:
    `MappingException` - Generally indicates an issue accessing the passed mapping object.

### dictatedSizes

    public Size[] dictatedSizes(Mapping mapping)
                         throws MappingException

  Description copied from interface: `Type`
  Return the column sizes dictated by this type. For example, the mapping for a `char`/`Character` would have a dictated length limit of 1; for a string-based `UUID` would have a size limit of 36; etc.

  NOTE: The number of elements in this array matches the return from `Type.getColumnSpan(org.hibernate.engine.spi.Mapping)`.

  Parameters:
    `mapping` - The mapping object :/
  Returns:
    The dictated sizes.
  Throws:
    `MappingException` - Generally indicates an issue accessing the passed mapping object.

### defaultSizes

    public Size[] defaultSizes(Mapping mapping)
                        throws MappingException

  Description copied from interface: `Type`
  Defines the column sizes to use according to this type if the user did not explicitly say (and if no `Type.dictatedSizes(org.hibernate.engine.spi.Mapping)` were given).

  NOTE: The number of elements in this array matches the return from `Type.getColumnSpan(org.hibernate.engine.spi.Mapping)`.

  Parameters:
    `mapping` - The mapping object :/
  Returns:
    The default sizes.
  Throws:
    `MappingException` - Generally indicates an issue accessing the passed mapping object.

### getColumnSpan

    public int getColumnSpan(Mapping mapping)
                      throws MappingException

  Description copied from interface: `Type`
  How many columns are used to persist this type. Always the same as `sqlTypes(mapping).length`

  Parameters:
    `mapping` - The mapping object :/
  Returns:
    The number of columns
  Throws:
    `MappingException` - Generally indicates an issue accessing the passed mapping object.

### setToXMLNode

    public void setToXMLNode(org.dom4j.Node node,
                             Object value,
                             SessionFactoryImplementor factory)
                      throws HibernateException

  Description copied from interface: `Type`
  A representation of the value to be embedded in an XML element.

  Parameters:
    `node` - The XML node to which to write the value
    `value` - The value to write
    `factory` - The session factory
  Throws:
    `HibernateException` - An error from Hibernate

### fromXMLNode

    public Object fromXMLNode(org.dom4j.Node xml,
                              Mapping factory)
                       throws HibernateException

  Description copied from interface: `Type`
  Parse the XML representation of an instance.

  Parameters:
    `xml` - The XML node from which to read the value
    `factory` - The session factory
  Returns:
    an instance of the `mapped class`
  Throws:
    `HibernateException` - An error from Hibernate

Copyright © 2001-2012 Red Hat, Inc. All Rights Reserved.